package de.kwoxer.www;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;

/**
 * @author kwoxer
 */

public class ColorFilter {
	private BufferedImage bufferedImage;
	private int height;
	private int width;

	public void setHeight(int height) {
		this.height = height;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public int getHeight() {
		return height;
	}

	public int getWidth() {
		return width;
	}

	/**
	 * @param args
	 */
	public ColorFilter(String path) {
		try {
			bufferedImage = ImageIO.read(new File(path));
		} catch (IOException e) {
			e.printStackTrace();
		}
		setHeight(bufferedImage.getHeight());
		setWidth(bufferedImage.getWidth());
	}

	public int[][][] filterRBG() {
		Color color;
		int[][][] helpArray = new int[width][height][3];
		for (int x = 0, maxX = width - 1; x <= maxX; x++) {
			for (int y = 0, maxY = height - 1; y <= maxY; y++) {
				int rgb = bufferedImage.getRGB(x, y);
				color = new Color(rgb);
				helpArray[x][y][0] = color.getRed();
				helpArray[x][y][1] = color.getGreen();
				helpArray[x][y][2] = color.getBlue();
			}
		}
		return helpArray;
	}

	public float[][][] filterRed() {
		Color color = null;
		float[] colors = new float[3];
		float[][][] helpArray = new float[width][height][3];
		for (int x = 0, maxX = width - 1; x <= maxX; x++) {
			for (int y = 0, maxY = height - 1; y <= maxY; y++) {
				int rgb = bufferedImage.getRGB(x, y);
				color = new Color(rgb);
				Color.RGBtoHSB(color.getRed(), color.getGreen(), color.getBlue(), colors);
				helpArray[x][y][0] = colors[0];
				helpArray[x][y][1] = colors[1];
				helpArray[x][y][2] = colors[2];
			}
		}
		return helpArray;
	}
}